/*****************************************************************************/
/*                                                                           */
/*                           OCO SOURCE MATERIALS                            */
/*                             IBM CONFIDENTIAL                              */
/*                                    OR                                     */
/*                        IBM CONFIDENTIAL RESTRICTED                        */
/*            WHEN COMBINED WITH THE AGGREGATED OCO SOURCE MODULES           */
/*                           FOR THIS PROGRAM PRODUCT                        */
/*                                                                           */
/*   VisualAge Generator Server for OS/2, AIX, HP-UX, SUN, and Windows NT    */
/*                          Version 4.0  5697-C28                            */
/*                    (C) COPYRIGHT IBM CORP. 1994,1999                      */
/*                                                                           */
/*****************************************************************************/

#ifndef FCWUIDRV_H
#define FCWUIDRV_H

/*-------------------------------------------------------------------------*/
/*  Class definition for User Interface Record Driver                      */
/*-------------------------------------------------------------------------*/

class UIRDriver
{
  private:
    CSOGWS*       pGWS;
    CSOGWS*       pGWSCurrOffset;
    char          sessionId[9];
    char          userKey[9];
    Bool          pendingFirstUI;
    Bool          processingFirstUI;
    Bool          skippingFirstUI;
    Bool          noAppname;

  public:
                   UIRDriver();
    virtual       ~UIRDriver();


    void          BuildUIErrorRec();
    void          ClrGwsBeanName();
    void          ClrGwsProgName();
    virtual  void ConverseUI() {};
    CSOGWS*       GetpGWS();
    char*         GetGwsBeanName();
    char          GetGwsBypassEdit();
    CSOGWS*       GetGwsCurrOffset();
    long          GetGwsDataLength();
    char          GetGwsEzeAid();
    long          GetGwsHashCode();
    char*         GetGwsSessionId();
    char          GetGwsSSMByte();
    char*         GetGwsUserKey();
    Bool          IsFirstUIPending();
    Bool          NoAppname();
    Bool          ProcessingFirstUI();
    Bool          SkippingFirstUI();
    void          SetpGWS();
    void          SetFirstUIPending( Bool );
    void          SetGwsBeanName( char* );
    void          SetGwsCurrOffset( CSOGWS* );
    void          SetGwsDataLength( long );
    void          SetGwsProgName( char* );
    void          SetGwsSSMByte( char );
    void          SetNoAppname( Bool );
    void          SetProcessingFirstUI( Bool );
    void          SetSkippingFirstUI( Bool );
    virtual  void Terminate( TermType ) {};
};

class UIRCicsDriver : public UIRDriver
{
  private:

  public:

    void          ConverseUI();
    void          Terminate( TermType );

};

class UIRNativeDriver : public UIRDriver
{
  private:
    void          BuildUINormalTermRec();
    void          ConverseUITermRec();

  public:
                   UIRNativeDriver();
    virtual       ~UIRNativeDriver();


    void          ConverseUI();
    void          Terminate( TermType );
    Bool          terminated;
    Bool          IsTerminated();
    void          SetTerminated();
};

inline
Bool UIRNativeDriver :: IsTerminated()
{
   return terminated;
}

inline 
void UIRNativeDriver :: SetTerminated()
{ 
   terminated = True;
}

#endif
